
package io.fabric8.swagger.model;

import java.util.ArrayList;
import java.util.List;
import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "path",
    "description",
    "operations"
})
@ToString
@EqualsAndHashCode
public class ApiObject {

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("path")
    @Pattern(regexp = "^/")
    @NotNull
    private String path;
    @JsonProperty("description")
    private String description;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("operations")
    @Valid
    @NotNull
    private List<OperationObjectJson> operations = new ArrayList<OperationObjectJson>();

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("path")
    public String getPath() {
        return path;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("path")
    public void setPath(String path) {
        this.path = path;
    }

    @JsonProperty("description")
    public String getDescription() {
        return description;
    }

    @JsonProperty("description")
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("operations")
    public List<OperationObjectJson> getOperations() {
        return operations;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("operations")
    public void setOperations(List<OperationObjectJson> operations) {
        this.operations = operations;
    }

}
